import { GenericHkt, genericNode } from "@ark/schema";
import { liftArray } from "@ark/util";
import { scope } from "../scope.js";
import { tsKeywords } from "./tsKeywords.js";
const ArkLiftArray = genericNode("element")(args => args.element.or(args.element.array()).pipe(liftArray), class liftArrayHkt extends GenericHkt {
});
const ArkMerge = genericNode(["base", tsKeywords.object], ["props", tsKeywords.object])(args => args.base.merge(args.props), class mergeHkt extends GenericHkt {
});
const arkGenericsExports = {
    liftArray: ArkLiftArray,
    merge: ArkMerge
};
const $ = scope(arkGenericsExports, {
    prereducedAliases: true
});
export const arkGenerics = $.export();
