import { GenericHkt, genericNode } from "@ark/schema";
import { scope } from "../scope.js";
import { internal } from "./internal.js";
import { tsKeywords } from "./tsKeywords.js";
const Record = genericNode(["K", internal.key], "V")(args => ({
    domain: "object",
    index: {
        signature: args.K,
        value: args.V
    }
}), class RecordHkt extends GenericHkt {
});
const Pick = genericNode(["T", tsKeywords.object], ["K", internal.key])(args => args.T.pick(args.K), class PickHkt extends GenericHkt {
});
const Omit = genericNode(["T", tsKeywords.object], ["K", internal.key])(args => args.T.omit(args.K), class OmitHkt extends GenericHkt {
});
const Partial = genericNode(["T", tsKeywords.object])(args => args.T.partial(), class PartialHkt extends GenericHkt {
});
const Required = genericNode(["T", tsKeywords.object])(args => args.T.required(), class RequiredHkt extends GenericHkt {
});
const Exclude = genericNode("T", "U")(args => args.T.exclude(args.U), class ExcludeHkt extends GenericHkt {
});
const Extract = genericNode("T", "U")(args => args.T.extract(args.U), class ExtractHkt extends GenericHkt {
});
const tsGenericsExports = {
    Record,
    Pick,
    Omit,
    Exclude,
    Extract,
    Partial,
    Required
};
const $ = scope(tsGenericsExports, {
    prereducedAliases: true
});
export const tsGenerics = $.export();
